#!/bin/sh
#
#

datadirpostrain=datasetsSCOP1.53/positive-training-extended
datadirnegtrain=datasetsSCOP1.53/original-dataset
datadirpostest=datasetsSCOP1.53/original-dataset
datadirnegtest=datasetsSCOP1.53/original-dataset

lstmdir=lstmrun
ext=fasta

template=mem14.ws11

rm $lstmdir/lstm*
rm $lstmdir/wei*.mat

cp src/lstm $lstmdir/lstm

# copy template parameterfile
for data in $datadirpostrain/pos-train.*.$ext; do
    tmp=${data%.$ext}
    tmp=${tmp#*$datadirpostrain/}
    sid=${tmp##pos-train.}
    datafile=${tmp}.$ext
    cp lstmpars.$template.template $lstmdir/lstmpars.${sid}.txt
    #echo $datafile $sid
    perl -pi -e "s#XXXpostrainXXX#../$datadirpostrain/pos-train.$sid.$ext#g" ${lstmdir}/lstmpars.${sid}.txt
    perl -pi -e "s#XXXpostestXXX#../$datadirpostest/pos-test.$sid.$ext#g" ${lstmdir}/lstmpars.${sid}.txt
    perl -pi -e "s#XXXnegtrainXXX#../$datadirnegtrain/neg-train.$sid.$ext#g" ${lstmdir}/lstmpars.${sid}.txt
    perl -pi -e "s#XXXnegtestXXX#../$datadirnegtest/neg-test.$sid.$ext#g" ${lstmdir}/lstmpars.${sid}.txt
done

# run training

cd $lstmdir

for data in `ls lstmpars.*.txt`; do
    sid=${data%.txt}
    sid=${sid##lstmpars.}

    #if [ -f ../wmsload/weight.$sid.mat ]; then
        echo $sid
        rm current.*.txt
        touch current.${sid}.txt
        cat /dev/null >  out.txt
        nice -n 19 ./lstm -c lstmpars.${sid}.txt
        #nice -n 19 ./lstm -c lstmpars.${sid}.txt -w ../wmsload/weight.$sid.mat
        cp out.txt ../out/out.$sid.txt
        cp weight.mat ../wms/weight.$sid.mat
    #fi

done
